Attribute VB_Name = "Mainsub"
Option Explicit

'*******************************************************************
'PUBLIC CONSTANTS
    'Header Height of Form
    Public Const HeaderHeight As Long = 25
    
    'Player Ship
    Public Const ShipWidth As Long = 47
    Public Const ShipHeight As Long = 32
    
    'Shots
    Public Const MaxShots As Long = 5
    Public Const ShotSize As Long = 5
    Public Const ShotSpeed As Long = 10
    Public Const MaxAmmo As Long = 500
    
    'Enemy Shots
    Public Const MaxEShots As Long = 10
    Public Const EShotSize As Long = 5
    Public Const EShotSpeed As Long = 10
    Public Const MaxBosses As Long = 3
    
    'Timing
    Public Const TickDifference_Shot As Long = 300
    Public Const TickDifference_EShot As Long = 300
    Public Const TickDifference_Inv As Long = 2000
    Public Const TickDifference_Fuel As Long = 2000
    
    'Stars
    Public Const MaxStarSize As Long = 2
    Public Const MaxStarSpeed As Long = 5

    'Enemy
    Public Const MaxEnemy As Long = 11
    Public Const MaxEnemyOnScreen As Long = 10
    Public Const MaxEnemySpeed As Long = 15
    Public Const MaxBossShield As Long = 5
    
    'Fuel Ship
    Public Const FuelShipWidth As Long = 1313
    Public Const FuelShipHeight As Long = 214
    
    'Score
    Public Const HiScoreFileName As String = "\Hiscore.txt"
    Public Const MaxScore As Long = 10
    Public Const ExtraLifeScore As Long = 10000
    Public Const MaximumScore As Long = 100
'*******************************************************************

'*******************************************************************
'PUBLIC TYPES
'Star Type
    Public Type Star
        X As Long
        Y As Long
        Speed As Long
        Size As Long
        Color As Long
    End Type
'*******************************************************************

'*******************************************************************
'GLOBAL VARIABLES

    'Player Ship
    Global ShipBMP As Long
    Global MaskBMP As Long
    Global ShipX As Long
    Global ShipY As Long
    Global ShipLife As Long
    Global ShipXSpeed As Long
    Global ShipYSpeed As Long
    Global ShipMaxLives As Long
    
    'Shots
    Global ShotX(MaxShots) As Long
    Global ShotY(MaxShots) As Long
    Global ShotActive(MaxShots) As Boolean
    Global ShotColor As Long
    Global Ammo As Long
    
    'Boss Shots
    Global EShotX(MaxBosses, MaxEShots) As Long
    Global EShotY(MaxBosses, MaxEShots) As Long
    Global EShotActive(MaxBosses, MaxEShots) As Boolean
    Global EShotColor As Long
    
    'Timing
    Global LastTick As Long
    Global CurrentTick As Long
    Global TickDifference As Long
    Global LastTick_Shot As Long
    Global CurrentTick_Shot As Long
    Global LastTick_EShot(1 To MaxBosses) As Long
    Global CurrentTick_EShot(1 To MaxBosses) As Long
    Global LastTick_Inv As Long
    Global CurrentTick_Inv As Long
    Global LastTick_Fuel As Long
    Global CurrentTick_Fuel As Long
    Global bLoopRunning As Boolean

    'Stars
    Global SpaceColor As Long
    Global Stars(100) As Star
    
    'Enemy Ships
    Global EnemyShipBMP(1 To MaxEnemy) As Long
    Global EnemyMaskBMP(1 To MaxEnemy) As Long
    Global EnemyWidth(1 To MaxEnemy) As Long
    Global EnemyHeight(1 To MaxEnemy) As Long
    Global EnemyX(1 To MaxEnemyOnScreen) As Long
    Global EnemyY(1 To MaxEnemyOnScreen) As Long
    Global EnemySpeed(1 To MaxEnemyOnScreen) As Long
    Global EnemyAlive(1 To MaxEnemyOnScreen) As Long
    Global EnemyMove(1 To MaxEnemyOnScreen) As Long
    Global BossShield(1 To MaxEnemyOnScreen) As Long
    Global EnemyExploding(1 To MaxEnemyOnScreen) As Long
    
    'Fuel Ship
    Global FuelShipBMP As Long
    Global FuelMaskBMP As Long
    Global FuelShipX As Double
    Global FuelShipY As Double
    Global NewCall As Boolean
    Global FuelShipActive As Boolean
    Global FuelShipSpeed As Double
        
    'Game Variables
    Global Wave As Long
    Global NewWave As Boolean
    Global EnemiesPerWave As Long
    Global Level As Long
    Global Invincible As Boolean
    Global Score As Long
    Global Sign(1 To MaxBosses) As Long
    Global CurrentEnemy As Long
    Global GamePaused As Boolean
    
    'Score Variables
    Global HiScore(1 To MaxScore) As Long
    Global HiName(1 To MaxScore) As String
    Global ScorePosition As Long
    Global ExtraScore As Long

    
'*******************************************************************

Sub Main()
On Error GoTo ErrorHandler
Dim I As Long

'**************************************************************
'Define Sprite Information
    ShipBMP = GenerateDC(App.Path & "\Ship.bmp")
    MaskBMP = GenerateDC(App.Path & "\Shipmask.bmp")
    FuelShipBMP = GenerateDC(App.Path & "\FuelShip.bmp")
    FuelMaskBMP = GenerateDC(App.Path & "\Fuelmask.bmp")
    
    For I = 1 To MaxEnemy
        EnemyShipBMP(I) = GenerateDC(App.Path & "\Enemy Ship " & I & ".bmp")
        EnemyMaskBMP(I) = GenerateDC(App.Path & "\Enemy Mask " & I & ".bmp")
    Next I
    
    'Define Enemy Ship Info
        EnemyWidth(1) = 53
        EnemyHeight(1) = 32
        EnemyWidth(2) = 38
        EnemyHeight(2) = 32
        EnemyWidth(3) = 107
        EnemyHeight(3) = 32
        EnemyWidth(4) = 41
        EnemyHeight(4) = 32
        EnemyWidth(5) = 84
        EnemyHeight(5) = 32
        EnemyWidth(6) = 54
        EnemyHeight(6) = 32
        EnemyWidth(7) = 45
        EnemyHeight(7) = 32
        EnemyWidth(8) = 51
        EnemyHeight(8) = 32
        EnemyWidth(9) = 17
        EnemyHeight(9) = 15
        EnemyWidth(10) = 55
        EnemyHeight(10) = 56
        EnemyWidth(11) = 57
        EnemyHeight(11) = 48
        
'**************************************************************


'**************************************************************
'  Define Colors
    Color_Set
'**************************************************************

'**************************************************************
'Load High Score Data
    Close #1
    Open App.Path & HiScoreFileName For Input As #1
    'Set Variables to Data from File
    For I = 1 To MaxScore
        Input #1, HiScore(I), HiName(I)
    Next I
    Close #1
    
'**************************************************************

'**************************************************************
'Start Form
    DisplayForm.Show
'**************************************************************

ErrorHandler:
    Select Case Err
        Case 0 'No error
                           
        Case Else
            MsgBox Err.Description
            CleanUp
    End Select


End Sub

Sub GameLoop()
Dim I As Long
Dim J As Long

'**************************************************************
'**************************************************************
'Game Loop
    Do
        CurrentTick = GetTickCount()
           
        If CurrentTick - LastTick > TickDifference Then
        
        '**************************************************************
        '   Game Controls and Calculations
            
                'Move Ship Subroutine
                MoveShip
                
                'Shoot if Space is held down
                If GetKeyState(vbKeySpace) < 0 Then
                    Shoot
                End If
                
                'Jump Out
                If GetKeyState(vbKeyEscape) < 0 Then
                    bLoopRunning = False
                    CleanUp
                    End
                End If
                                                
                'Determine if any shots hit
                ShotCollision
                
                'Update Enemy data
                If FuelShipActive = False Then
                    WaveSub
                End If
                
                'Is ship shielding necessary due to a new life
                Invincible_Test
                
                'Is the ship shielded by some other means
                If GetKeyState(vbKeyControl) < 0 And Ammo > 0 Then
                    Invincible = True
                    Ammo = Ammo - 1
                End If
                
                'Pause Game
                If GetKeyState(vbKeyP) < 0 Then
                    bLoopRunning = False
                    GamePaused = True
                End If
                
                'Determine if the ship hits any enemies
                ShipCollision
                
                'Make boss shoot if boss is active
                If Wave = 11 Then
                    For I = 1 To MaxBosses
                        If EnemyAlive(I) = True Then
                            CurrentEnemy = I
                            BossShoot
                        End If
                    Next I
                End If
                
                'Determine Fuel Ship Info
                If Ammo = 0 Then
                    NewCall = True
                End If
                
                FuelShipCall
                If FuelShipActive = True Then
                    'Check to see if ship is in ammo bay
                    If ShipX > FuelShipX + 587 Then
                        If ShipX + ShipWidth < FuelShipX + 587 + 2 * ShipWidth Then
                            If ShipY > FuelShipY + 150 Then
                                If ShipY + ShipHeight < FuelShipY + 150 + 2 * ShipHeight Then
                                    Ammo = MaxAmmo
                                End If
                            End If
                        End If
                    End If
                End If
                
                'Extra Life Determination
                If ExtraScore > ExtraLifeScore Then
                    ShipMaxLives = ShipMaxLives + 1
                    ExtraScore = 0
                End If
                
                'Is the game over due to last life
                If ShipLife > ShipMaxLives Then
                    bLoopRunning = False
                    Gameover
                    Exit Do
                End If
                
                'Update HUD
                DisplayForm.Text2.Text = ShipMaxLives - ShipLife + 1
                DisplayForm.Text3.Text = Level
                DisplayForm.Text6.Text = Wave
                DisplayForm.Text7.Text = Score
                DisplayForm.Text9.Text = Ammo
        '**************************************************************
        
        '**************************************************************
        '   Draw Data
            
            'Clear the form
                'BitBlt DisplayForm.hdc, 0, 0, DisplayForm.ScaleWidth, DisplayForm.ScaleHeight, 0, 0, 0, vbBlackness
                 DisplayForm.Cls
            'Draw Background
                For I = 0 To UBound(Stars)
                    'Move the star
                    Stars(I).X = (Stars(I).X) - Stars(I).Speed
                    'Relocate the Y position
                    If Stars(I).X < 0 Then
                      Stars(I).X = DisplayForm.ScaleWidth
                      Stars(I).Y = DisplayForm.ScaleHeight * Rnd + 1 + HeaderHeight
                      Stars(I).Speed = MaxStarSpeed * Rnd + 1
                    End If
                    'Set the color
                    DisplayForm.FillColor = Stars(I).Color
                    DisplayForm.ForeColor = Stars(I).Color
                    'Draw the star
                    Ellipse DisplayForm.hdc, Stars(I).X, Stars(I).Y, Stars(I).X + Stars(I).Size, Stars(I).Y + Stars(I).Size
                
                Next I
            
            'Draw the Ship
                BitBlt DisplayForm.hdc, ShipX, ShipY, ShipWidth, ShipHeight, MaskBMP, 0, 0, vbSrcAnd
                BitBlt DisplayForm.hdc, ShipX, ShipY, ShipWidth, ShipHeight, ShipBMP, 0, 0, vbSrcPaint
               
            'Draw the Invinciblity Ring if Applicable
                If Invincible = True Then
                    DisplayForm.FillStyle = 1
                    DisplayForm.ForeColor = Blue
                    Ellipse DisplayForm.hdc, ShipX - 2, ShipY - 2, ShipX + ShipWidth + 2, ShipY + ShipHeight + 2
                    DisplayForm.FillStyle = 0
                End If
                
            'Draw the Boss Shield if Applicable
                If Wave = 11 Then
                    For I = 1 To EnemiesPerWave
                        If EnemyAlive(I) = True Then
                            For J = BossShield(I) To MaxBossShield - 1
                                DisplayForm.FillStyle = 1
                                DisplayForm.ForeColor = LtBlue
                                Ellipse DisplayForm.hdc, EnemyX(I) - (MaxBossShield - J), _
                                    EnemyY(I) - (MaxBossShield - J), EnemyX(I) + EnemyWidth(Wave) + (MaxBossShield - J), _
                                    EnemyY(I) + EnemyHeight(Wave) + (MaxBossShield - J)
                                DisplayForm.FillStyle = 0
                            Next J
                        End If
                    Next I
                End If
              
            'Draw the Shots
                For I = 1 To MaxShots
                    If ShotActive(I) = True Then
                        ShotX(I) = ShotX(I) + ShotSpeed
                        DisplayForm.FillColor = ShotColor
                        DisplayForm.ForeColor = ShotColor
                        Ellipse DisplayForm.hdc, ShotX(I), ShotY(I), ShotX(I) + ShotSize, ShotY(I) + ShotSize
                        If ShotX(I) > DisplayForm.ScaleWidth Then ShotActive(I) = False
                    End If
                Next I
                
            'Draw the Opposition
                For I = 1 To EnemiesPerWave
                    If EnemyAlive(I) = True Then
                        BitBlt DisplayForm.hdc, EnemyX(I), EnemyY(I), EnemyWidth(Wave), EnemyHeight(Wave), EnemyMaskBMP(Wave), 0, 0, vbSrcAnd
                        BitBlt DisplayForm.hdc, EnemyX(I), EnemyY(I), EnemyWidth(Wave), EnemyHeight(Wave), EnemyShipBMP(Wave), 0, 0, vbSrcPaint
                    End If
                Next I
                
            'Draw Exploding Ships
                For I = 1 To EnemiesPerWave
                    If EnemyExploding(I) > 0 Then
                        'Set the color
                        DisplayForm.FillColor = RGB(252 - EnemyExploding(I), 55 + EnemyExploding(I), 70) 'Red
                        DisplayForm.ForeColor = RGB(252 - EnemyExploding(I), 55 + EnemyExploding(I), 70)  'Red
                        'Draw the explosion
                        Ellipse DisplayForm.hdc, EnemyX(I) + EnemyWidth(Wave) / 2 - EnemyExploding(I), _
                            EnemyY(I) + EnemyHeight(Wave) / 2 - EnemyExploding(I), _
                            EnemyX(I) + EnemyWidth(Wave) / 2 + EnemyExploding(I), _
                            EnemyY(I) + EnemyHeight(Wave) / 2 + EnemyExploding(I)
                        EnemyExploding(I) = EnemyExploding(I) + 1
                        If EnemyExploding(I) > 20 Then EnemyExploding(I) = 0
                    End If
                Next I
                
            'Draw the Boss Shots
                If Wave = 11 Then
                    For J = 1 To MaxBosses
                        For I = 1 To MaxEShots
                            If EShotActive(J, I) = True Then
                                EShotX(J, I) = EShotX(J, I) - ShotSpeed
                                DisplayForm.FillColor = EShotColor
                                DisplayForm.ForeColor = EShotColor
                                Ellipse DisplayForm.hdc, EShotX(J, I), EShotY(J, I), EShotX(J, I) + ShotSize, EShotY(J, I) + ShotSize
                                If EShotX(J, I) < 0 Then EShotActive(J, I) = False
                            End If
                        Next I
                    Next J
                    BossShotCollision
                End If
                
            'Draw the FuelShip if Active
                If FuelShipActive = True Then
                    BitBlt DisplayForm.hdc, FuelShipX, FuelShipY, FuelShipWidth, FuelShipHeight, FuelMaskBMP, 0, 0, vbSrcAnd
                    BitBlt DisplayForm.hdc, FuelShipX, FuelShipY, FuelShipWidth, FuelShipHeight, FuelShipBMP, 0, 0, vbSrcPaint
                End If
                
            'Draw the Header Line
                DisplayForm.Line (0, HeaderHeight)-(DisplayForm.ScaleWidth, HeaderHeight), White
                
            LastTick = GetTickCount()
            DisplayForm.Refresh
            DisplayForm.CollisionPict.Refresh
        '**************************************************************
        
        End If

        DoEvents
    
    Loop While bLoopRunning
'**************************************************************
'**************************************************************

End Sub

Sub CleanUp()
Dim I As Long
'Remove All Bitmaps from Memory
'  It is critical to remove all DC data to keep resources cleaned up and stop memory leaks
    DeleteGeneratedDC ShipBMP
    DeleteGeneratedDC MaskBMP
    DeleteGeneratedDC FuelShipBMP
    DeleteGeneratedDC FuelMaskBMP
    
    For I = 1 To MaxEnemy
        DeleteGeneratedDC EnemyShipBMP(I)
        DeleteGeneratedDC EnemyMaskBMP(I)
    Next I

    Unload DisplayForm
    Set DisplayForm = Nothing

End Sub

Sub MoveShip()
'Adjust the Basic Location Data of the Ship
    
    'Determine Horizontal Location
        If GetKeyState(vbKeyRight) < 0 Then
            ShipX = ShipX + ShipXSpeed
        End If
        If GetKeyState(vbKeyLeft) < 0 Then
            ShipX = ShipX - ShipXSpeed
        End If
        
        If ShipX < 0 Then ShipX = 0
        If ShipX > DisplayForm.ScaleWidth - ShipWidth Then ShipX = DisplayForm.ScaleWidth - ShipWidth
        
    'Determine Vertical Location
        If GetKeyState(vbKeyUp) < 0 Then
            ShipY = ShipY - ShipYSpeed
        End If
        If GetKeyState(vbKeyDown) < 0 Then
            ShipY = ShipY + ShipYSpeed
        End If
        
        If ShipY < HeaderHeight Then ShipY = HeaderHeight
        If ShipY > DisplayForm.ScaleHeight - ShipHeight Then ShipY = DisplayForm.ScaleHeight - ShipHeight
    
End Sub

Sub Shoot()
Dim I As Long
Dim J As Long

        
        If CurrentTick - LastTick_Shot > TickDifference_Shot Then
            If FuelShipActive = False Then
                If Ammo > 0 Then
                    For I = 1 To MaxShots
                        If ShotActive(I) = False Then
                            ShotActive(I) = True
                            ShotX(I) = ShipX + ShipWidth * 0.9
                            ShotY(I) = ShipY + 0.35 * ShipHeight
                            Ammo = Ammo - 1
                            Exit For
                        End If
                    Next I
                End If
            End If
            LastTick_Shot = GetTickCount()
        End If
        
End Sub

Sub BossShoot()
Dim I As Long
Dim J As Long

        CurrentTick = GetTickCount()
        If CurrentTick - LastTick_EShot(CurrentEnemy) > TickDifference_EShot Then
                For I = 1 To MaxEShots
                    If EShotActive(CurrentEnemy, I) = False Then
                        EShotActive(CurrentEnemy, I) = True
                        EShotX(CurrentEnemy, I) = EnemyX(CurrentEnemy) + EnemyWidth(Wave) * 0.9
                        EShotY(CurrentEnemy, I) = EnemyY(CurrentEnemy) + 0.35 * EnemyHeight(Wave)
                        Exit For
                    End If
                Next I
            LastTick_EShot(CurrentEnemy) = GetTickCount()
        End If
        
End Sub

Sub Invincible_Test()
Dim I As Long
Dim J As Long

    If Invincible = True Then
        If CurrentTick - LastTick_Inv > TickDifference_Inv Then
            Invincible = False
        End If
    End If
        
End Sub

Sub ShipCollision()
Dim I As Long
Dim J As Long
Dim K As Long
Dim Collision As Boolean
Dim Extent As Boolean
Dim SMX As Long
Dim SMY As Long
Dim EMX As Long
Dim EMY As Long
Dim ColWidth As Long
Dim ColHeight As Long

Extent = False
Collision = False
'Clear Collision PBox
BitBlt DisplayForm.CollisionPict.hdc, 0, 0, DisplayForm.CollisionPict.ScaleWidth, DisplayForm.CollisionPict.ScaleHeight, 0, 0, 0, vbBlackness


    'ShipCollision Detection
    If FuelShipActive = False Then
        If Invincible = False Then
            For I = 1 To EnemiesPerWave
                If EnemyAlive(I) = True Then
                    If ShipX + ShipWidth > EnemyX(I) Then
                        If ShipX < EnemyX(I) + EnemyWidth(Wave) Then
                            If ShipY + ShipHeight > EnemyY(I) Then
                                If ShipY < EnemyY(I) + EnemyHeight(Wave) Then
                                    'Extent Collision, now determine if pixel collision
                                    Extent = True
                                                                    
                                    'Determine the amount of the masks to transfer
                                    If ShipX <= EnemyX(I) Then
                                        ColWidth = ShipX + ShipWidth - EnemyX(I)
                                        SMX = ShipWidth - ColWidth
                                        EMX = 0
                                    Else
                                        ColWidth = EnemyX(I) + EnemyWidth(Wave) - ShipX
                                        SMX = 0
                                        EMX = EnemyWidth(Wave) - ColWidth
                                    End If
                                    
                                    If ShipY <= EnemyY(I) Then
                                        ColHeight = ShipY + ShipHeight - EnemyY(I)
                                        SMY = ShipHeight - ColHeight
                                        EMY = 0
                                    Else
                                        ColHeight = EnemyY(I) + EnemyHeight(Wave) - ShipY
                                        SMY = 0
                                        EMY = EnemyHeight(Wave) - ColHeight
                                    End If
                                    
                                    'Draw the masks on the picturebox
                                    BitBlt DisplayForm.CollisionPict.hdc, 0, 0, ColWidth, ColHeight, MaskBMP, SMX, SMY, vbSrcPaint
                                    BitBlt DisplayForm.CollisionPict.hdc, 0, 0, ColWidth, ColHeight, EnemyMaskBMP(Wave), EMX, EMY, vbSrcPaint
                                    DisplayForm.CollisionPict.Refresh
                                    
                                    'Check the Picture box for any black pixels
                                    For J = 1 To ColWidth - 2
                                        For K = 1 To ColHeight - 2
                                            If DisplayForm.CollisionPict.Point(J, K) < 16000000 Then
                                                Collision = True
                                                EnemyAlive(I) = False
                                                Exit For
                                            End If
                                        Next K
                                        If Collision = True Then Exit For
                                    Next J
                                            
                                End If
                            End If
                        End If
                    End If
                End If
                
            Next I
        End If
    Else
        'Does it Collide with refuel ship
        If ShipX + ShipWidth > FuelShipX Then
            If ShipX < FuelShipX + FuelShipWidth Then
                If ShipY + ShipHeight > FuelShipY Then
                    If ShipY < FuelShipY + FuelShipHeight Then
                        'Extent Collision, now determine if pixel collision
                        Extent = True
                                                        
                        'Determine the amount of the masks to transfer
                        If ShipX <= FuelShipX Then
                            ColWidth = ShipX + ShipWidth - FuelShipX
                            SMX = ShipWidth - ColWidth
                            EMX = 0
                        Else
                            ColWidth = FuelShipX + FuelShipWidth - ShipX
                            SMX = 0
                            EMX = FuelShipWidth - ColWidth
                            'EMX = ShipX - FuelShipX
                        End If
                        
                        If ShipY <= FuelShipY Then
                            ColHeight = ShipY + ShipHeight - FuelShipY
                            SMY = ShipHeight - ColHeight
                            EMY = 0
                        Else
                            ColHeight = FuelShipY + FuelShipHeight - ShipY
                            SMY = 0
                            EMY = FuelShipHeight - ColHeight
                            'EMY = ShipY - FuelShipY
                        End If
                        
                        'Draw the masks on the picturebox
                        If ColWidth > ShipWidth Then ColWidth = ShipWidth
                        If ColHeight > ShipHeight Then ColHeight = ShipHeight
                        
                        BitBlt DisplayForm.CollisionPict.hdc, 0, 0, ColWidth, ColHeight, MaskBMP, SMX, SMY, vbSrcPaint
                        BitBlt DisplayForm.CollisionPict.hdc, 0, 0, ColWidth, ColHeight, FuelMaskBMP, EMX, EMY, vbSrcPaint
                        DisplayForm.CollisionPict.Refresh

                        'Check the Picture box for any black pixels
                        For J = 1 To ColWidth - 2
                            For K = 1 To ColHeight - 2
                                If DisplayForm.CollisionPict.Point(J, K) < 16000000 Then
                                    Collision = True
                                    Exit For
                                End If
                            Next K
                            If Collision = True Then Exit For
                        Next J
                             
                    End If
                End If
            End If
        End If
    End If
     
Collided:

    'Debug.Print Extent, Collision
    If Collision = True Then
        NewWave = False
        ShipLife = ShipLife + 1
        ShipExplodes
    End If
        
End Sub

Sub ShipExplodes()
Dim I As Long
Dim NoGood As Boolean

    NoGood = False
    bLoopRunning = False
    For I = 1 To 10
        'Set the color
        DisplayForm.FillColor = RGB(252 - I * 10, 55 + I * 10, 34) 'Red
        DisplayForm.ForeColor = RGB(252 - I * 10, 55 + I * 10, 34) 'Red
        'Draw the explosion
        Ellipse DisplayForm.hdc, ShipX - ShipHeight - I * 2, ShipY - ShipHeight - I / 2, ShipX + ShipWidth + ShipHeight + I * 2, ShipY + ShipHeight * 2 + I * 2
        Sleep 50
        DisplayForm.Refresh
    Next I
    ShipX = 1 / 4 * DisplayForm.ScaleWidth - ShipWidth / 2
    ShipY = 1 / 2 * DisplayForm.ScaleHeight - ShipHeight
    Invincible = True
    Ammo = MaxAmmo
    LastTick_Inv = GetTickCount()
    NewCall = False
    FuelShipActive = False
    bLoopRunning = True

End Sub

Sub ShotCollision()
Dim I As Long
Dim J As Long

        'Shot Collision Detection
        For J = 1 To MaxShots
            If ShotActive(J) = True Then
                For I = 1 To EnemiesPerWave
                    If EnemyAlive(I) = True Then
                        If ShotX(J) < EnemyX(I) + EnemyWidth(Wave) Then
                            If ShotX(J) > EnemyX(I) Then
                                If ShotY(J) < EnemyY(I) + EnemyHeight(Wave) Then
                                    If ShotY(J) > EnemyY(I) Then
                                        If Wave = 11 Then
                                            BossShield(I) = BossShield(I) + 1
                                            ShotActive(J) = False
                                        Else
                                            EnemyAlive(I) = False
                                            ShotActive(J) = False
                                            If Wave <> 11 Then
                                                If Wave * Level * 10 > MaximumScore Then
                                                    Score = Score + MaximumScore
                                                    ExtraScore = ExtraScore + MaximumScore
                                                Else
                                                    Score = Score + Wave * Level * 10
                                                    ExtraScore = ExtraScore + Wave * Level * 10
                                                End If
                                            End If
                                            EnemyExploding(I) = 1
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    
                        If BossShield(I) > MaxBossShield And Wave = 11 Then
                            EnemyAlive(I) = False
                            EnemyExploding(I) = 1
                            Score = Score + Wave * Level * 10
                            ExtraScore = ExtraScore + Wave * Level * 10
                        End If
                    End If
                Next I
            End If
        Next J
        
End Sub

Sub BossShotCollision()
Dim I As Long
Dim J As Long

        'Shot Collision Detection
        For I = 1 To MaxBosses
            For J = 1 To MaxEShots
                If EShotActive(I, J) = True Then
                    If EShotX(I, J) < ShipX + ShipWidth Then
                        If EShotX(I, J) > ShipX Then
                            If EShotY(I, J) < ShipY + ShipHeight Then
                                If EShotY(I, J) > ShipY Then
                                    If Invincible = False Then
                                        NewWave = False
                                        ShipLife = ShipLife + 1
                                        ShipExplodes
                                        EShotActive(I, J) = False
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
            Next J
        Next I
        
End Sub
Sub WaveSub()
Dim I As Long
Dim GoWave As Boolean
    
    'SETUP NEW WAVE IF ALL PREVIOUS WAVE OBLITERATED
    If NewWave = True Then
        Select Case Wave
            
            Case 1 To 6
                If Level > 1 Then EnemiesPerWave = MaxEnemyOnScreen
                For I = 1 To EnemiesPerWave
                    EnemyX(I) = 0.9 * DisplayForm.ScaleWidth + I * 0.1 * DisplayForm.ScaleWidth
                    EnemyY(I) = I * DisplayForm.ScaleHeight / (EnemiesPerWave + 1)
                    EnemySpeed(I) = Level + Wave
                    EnemyAlive(I) = True
                    EnemyMove(I) = RandNum(-2, 2)
                    EnemyExploding(I) = 0
                Next I
                
            Case 7
                For I = 1 To EnemiesPerWave
                    EnemyY(I) = 0.9 * DisplayForm.ScaleHeight + I * 0.1 * DisplayForm.ScaleHeight
                    EnemyX(I) = DisplayForm.ScaleWidth / 8 + Rnd * (6 * DisplayForm.ScaleWidth / 8)
                    EnemySpeed(I) = Level + Wave
                    EnemyAlive(I) = True
                    EnemyExploding(I) = 0
                Next I
            Case 8
                EnemiesPerWave = 6
                For I = 1 To EnemiesPerWave
                    EnemyX(I) = 0 - I * 0.2 * DisplayForm.ScaleWidth
                    EnemyY(I) = I * DisplayForm.ScaleHeight / (EnemiesPerWave + 1)
                    EnemySpeed(I) = 4
                    EnemyAlive(I) = True
                    EnemyExploding(I) = 0
                Next I
                
            Case 9
                EnemiesPerWave = MaxEnemyOnScreen
                For I = 1 To EnemiesPerWave
                    EnemyX(I) = DisplayForm.ScaleWidth
                    EnemyY(I) = I * DisplayForm.ScaleHeight / (EnemiesPerWave + 1)
                    EnemySpeed(I) = Level
                    EnemyAlive(I) = True
                    EnemyExploding(I) = 0
                Next I
                
            Case 10
                EnemiesPerWave = MaxEnemyOnScreen
                For I = 1 To EnemiesPerWave / 2
                    EnemyX(I) = 0.9 * DisplayForm.ScaleWidth + I * RandNum(0, 3) / 10 * DisplayForm.ScaleWidth
                    EnemyY(I) = RandNum(0, 10) / 10 * DisplayForm.ScaleHeight
                    EnemySpeed(I) = 4
                    EnemyAlive(I) = True
                    EnemyMove(I) = RandNum(-2, 2)
                    EnemyExploding(I) = 0
                Next I
                For I = EnemiesPerWave / 2 To EnemiesPerWave
                    EnemyY(I) = 0.9 * DisplayForm.ScaleHeight + I * 0.1 * DisplayForm.ScaleHeight
                    EnemyX(I) = DisplayForm.ScaleWidth / 8 + Rnd * (6 * DisplayForm.ScaleWidth / 8)
                    EnemySpeed(I) = 4
                    EnemyAlive(I) = True
                    EnemyMove(I) = RandNum(-2, 2)
                    EnemyExploding(I) = 0
                Next I
            
            Case 11
                EnemiesPerWave = Level
                If EnemiesPerWave > MaxBosses Then EnemiesPerWave = MaxBosses
                For I = 1 To EnemiesPerWave
                    EnemyX(I) = 0.8 * DisplayForm.ScaleWidth
                    EnemyY(I) = DisplayForm.ScaleHeight * I / (EnemiesPerWave + 1)
                    EnemySpeed(I) = 10
                    EnemyAlive(I) = True
                    BossShield(I) = 1
                    Sign(I) = 1
                    EnemyExploding(I) = 0
                Next I
                
            Case Else

        End Select
        NewWave = False
        GoWave = False
        
    'UPDATE CURRENT WAVE
    Else
        Select Case Wave
        
            Case 1 To 3
                For I = 1 To EnemiesPerWave
                    If EnemyAlive(I) = True Then
                        EnemyX(I) = EnemyX(I) - EnemySpeed(I)
                        If EnemyX(I) < 0 - EnemyWidth(Wave) Then
                            EnemyX(I) = DisplayForm.ScaleWidth
                            If EnemySpeed(I) < MaxEnemySpeed Then _
                                EnemySpeed(I) = EnemySpeed(I) + 1
                        End If
                    End If
                Next I
                
            Case 4 To 6
            For I = 1 To EnemiesPerWave
                    If EnemyAlive(I) = True Then
                        EnemyX(I) = EnemyX(I) - EnemySpeed(I)
                        If EnemyX(I) < 0 - EnemyWidth(Wave) Then
                            EnemyX(I) = DisplayForm.ScaleWidth
                            If EnemySpeed(I) < MaxEnemySpeed Then _
                                EnemySpeed(I) = EnemySpeed(I) + 1
                        End If
                        
                        EnemyY(I) = EnemyY(I) - EnemyMove(I)
                        If EnemyY(I) < 0 + HeaderHeight Then
                            EnemyY(I) = DisplayForm.ScaleHeight - EnemyHeight(Wave)
                        ElseIf EnemyY(I) + EnemyHeight(Wave) > DisplayForm.ScaleHeight Then
                            EnemyY(I) = 0 + HeaderHeight
                        End If
                    End If
            Next I
                
            Case 7
                For I = 1 To EnemiesPerWave
                    If EnemyAlive(I) = True Then
                        EnemyY(I) = EnemyY(I) - EnemySpeed(I)
                        If EnemyY(I) < 0 + HeaderHeight Then
                            EnemyY(I) = DisplayForm.ScaleHeight
                            If EnemySpeed(I) < MaxEnemySpeed Then _
                                EnemySpeed(I) = EnemySpeed(I) + 1
                        End If
                    End If
                Next I
                
            Case 8
                For I = 1 To EnemiesPerWave
                    If EnemyAlive(I) = True Then
                        EnemyX(I) = EnemyX(I) + EnemySpeed(I)
                        If EnemyX(I) > DisplayForm.ScaleWidth Then
                            EnemyX(I) = 0 - EnemyWidth(Wave)
                        End If
                    End If
                Next I
                
            Case 9
                For I = 1 To EnemiesPerWave
                    If EnemyAlive(I) = True Then
                        EnemyX(I) = EnemyX(I) - EnemySpeed(I)
                        If EnemyX(I) < 0 - EnemyWidth(Wave) Then
                            EnemyX(I) = DisplayForm.ScaleWidth
                            If EnemySpeed(I) < MaxEnemySpeed Then _
                                EnemySpeed(I) = EnemySpeed(I) + 1
                        End If
                    End If
                Next I
                
            Case 10
                For I = 1 To EnemiesPerWave '/ 2
                    If EnemyAlive(I) = True Then
                        EnemyX(I) = EnemyX(I) - EnemySpeed(I)
                        If EnemyX(I) < 0 - EnemyWidth(Wave) Then
                            EnemyX(I) = DisplayForm.ScaleWidth
                            If EnemySpeed(I) < MaxEnemySpeed Then _
                                EnemySpeed(I) = EnemySpeed(I) + 1
                        End If
                        
                        EnemyY(I) = EnemyY(I) - EnemyMove(I)
                        If EnemyY(I) < 0 + HeaderHeight Then
                            EnemyY(I) = DisplayForm.ScaleHeight - EnemyHeight(Wave)
                        ElseIf EnemyY(I) + EnemyHeight(Wave) > DisplayForm.ScaleHeight Then
                            EnemyY(I) = 0 + HeaderHeight
                        End If
                    End If
                Next I
                
            Case 11
                For I = 1 To EnemiesPerWave
                    If EnemyAlive(I) = True Then
                        
                        EnemySpeed(I) = RandNum(1, 10) * Sign(I)
                        If EnemySpeed(I) = 0 Then EnemySpeed(I) = 3
                        
                        EnemyY(I) = EnemyY(I) + EnemySpeed(I)
                        
                        If EnemyY(I) > 0.9 * DisplayForm.ScaleHeight Then
                            EnemyY(I) = 0.9 * DisplayForm.ScaleHeight - 2
                            Sign(I) = -Sign(I)
                        ElseIf EnemyY(I) < 0.1 * DisplayForm.ScaleHeight Then
                            Sign(I) = -Sign(I)
                            EnemyY(I) = 0.1 * DisplayForm.ScaleHeight + 2
                        End If
                        
                        If EnemyY(I) < 0 + HeaderHeight Then
                            EnemyY(I) = DisplayForm.ScaleHeight - EnemyHeight(Wave)
                        ElseIf EnemyY(I) + EnemyHeight(Wave) > DisplayForm.ScaleHeight Then
                            EnemyY(I) = 0 + HeaderHeight
                        End If
                    End If
                Next I
                                
        End Select
    End If
    
    'ARE ALL SHIPS DEAD AND REQUIRE A NEW WAVE
    For I = 1 To EnemiesPerWave
        If EnemyAlive(I) = True Then
            GoWave = False
            Exit For
        ElseIf EnemyExploding(I) > 0 Then
            GoWave = False
            Exit For
        Else
            GoWave = True
        End If
    Next I
    
    'Activate New Wave
    If GoWave = True Then
        'Determine if Fuel Call is Necessary (Give
        CurrentTick_Fuel = GetTickCount()
        If CurrentTick_Fuel - LastTick_Fuel > TickDifference_Fuel Then
            DisplayForm.Label3.Visible = False
            NewWave = True
            Wave = Wave + 1
            EnemiesPerWave = EnemiesPerWave + 1
            If EnemiesPerWave > MaxEnemyOnScreen Then EnemiesPerWave = MaxEnemyOnScreen
            LastTick_Fuel = GetTickCount
        Else
            DisplayForm.Label3.Visible = True
            'Call Ammo Ship
            If GetKeyState(vbKeyShift) < 0 Then
                NewCall = True
                DisplayForm.Label3.Visible = False
            End If
            
        End If
    Else
        LastTick_Fuel = GetTickCount()
    End If
    
    If Wave > MaxEnemy Then
        Level = Level + 1
        Wave = 1
    End If
        
End Sub

Sub InitializeForm()
Dim I As Long
Dim J As Long

    '**************************************************************
    'Form Preparations
       DisplayForm.Label1.Left = DisplayForm.ScaleWidth / 2 - DisplayForm.Label1.Width / 2
       DisplayForm.Label2.Left = DisplayForm.ScaleWidth / 2 - DisplayForm.Label2.Width / 2
       DisplayForm.Label3.Left = DisplayForm.ScaleWidth / 2 - DisplayForm.Label3.Width / 2
       DisplayForm.Label4.Left = DisplayForm.ScaleWidth / 2 - DisplayForm.Label4.Width / 2
       DisplayForm.Label5.Left = DisplayForm.ScaleWidth / 2 - DisplayForm.Label5.Width / 2
       DisplayForm.Label6.Left = DisplayForm.ScaleWidth / 2 - DisplayForm.Label6.Width / 2
       DisplayForm.Label1.Visible = True
       DisplayForm.Label2.Visible = True
       DisplayForm.Label3.Visible = False
       DisplayForm.Label4.Visible = True
       DisplayForm.Label5.Visible = True
       
       DisplayForm.Text1.Visible = False
       DisplayForm.Text2.Visible = False
       DisplayForm.Text3.Visible = False
       DisplayForm.Text4.Visible = False
       DisplayForm.Text5.Visible = False
       DisplayForm.Text6.Visible = False
       DisplayForm.Text7.Visible = False
       DisplayForm.Text8.Visible = False
       DisplayForm.Text9.Visible = False
       DisplayForm.Text10.Visible = False
            
       DisplayForm.BackColor = SpaceColor
       DisplayForm.Cls
       DisplayForm.SetFocus

    '**************************************************************
    'Initialize Variables
        ShipX = 1 / 4 * DisplayForm.ScaleWidth - ShipWidth / 2
        ShipY = 1 / 2 * DisplayForm.ScaleHeight - ShipHeight
        ShipXSpeed = 5
        ShipYSpeed = 5
        
        bLoopRunning = False
        For I = 1 To MaxShots
            ShotActive(I) = False
        Next I
        For I = 1 To MaxBosses
            For J = 1 To MaxEShots
                EShotActive(I, J) = False
            Next J
        Next I
        
        
        ShotColor = Red
        EShotColor = Yellow
        SpaceColor = RGB(1, 0, 1)
        
        Randomize
        'Generate the 100 stars
        For I = LBound(Stars) To UBound(Stars)
            
            Stars(I).X = DisplayForm.ScaleWidth * Rnd + 1
            Stars(I).Y = DisplayForm.ScaleHeight * Rnd + 1 + HeaderHeight
            Stars(I).Size = MaxStarSize * Rnd + 1
            Stars(I).Speed = MaxStarSpeed * Rnd + 1
            Stars(I).Color = White 'RGB(Rnd * 255 + 1, Rnd * 255 + 1, Rnd * 255 + 1)
        Next I
        
        Level = 1
        Wave = 1
        NewWave = True
        EnemiesPerWave = 3
        ShipLife = 1
        ShipMaxLives = 3
        Invincible = True
        LastTick_Inv = GetTickCount()
        TickDifference = 10
        Score = 0
        ExtraScore = Score
        ScorePosition = 0
        NewCall = False
        FuelShipActive = False
        FuelShipSpeed = 0.75
        Ammo = MaxAmmo
        GamePaused = False
    '**************************************************************
    
End Sub


Sub FuelShipCall()
Dim I As Long

    If NewCall = True And FuelShipActive = False Then
        NewCall = False
        FuelShipActive = True
        FuelShipX = DisplayForm.ScaleWidth + 0.1 * DisplayForm.ScaleWidth
        FuelShipY = RandNum(1, 6) / 10 * DisplayForm.ScaleHeight
        For I = 1 To MaxEnemyOnScreen
            EnemyX(I) = DisplayForm.ScaleWidth + 0.1 * DisplayForm.ScaleWidth
        Next
    ElseIf FuelShipActive = True Then
        ShipXSpeed = 1
        ShipYSpeed = 1
        FuelShipX = FuelShipX - FuelShipSpeed
        For I = 1 To MaxEnemyOnScreen
            EnemyX(I) = DisplayForm.ScaleWidth + 0.1 * I * DisplayForm.ScaleWidth
        Next
        If FuelShipX + FuelShipWidth < 0 Then
            NewCall = False
            FuelShipActive = False
        End If
    Else
        ShipXSpeed = 5
        ShipYSpeed = 5
    End If
    
End Sub

Sub Gameover()
Dim I As Long
Dim J As Long

    'Load up the High Score Sheet and Handle inputs and such for it.
    
    'First Determine where current score falls in heirarchy of scores
    For I = 1 To MaxScore
        If Score > HiScore(I) Then
            ScorePosition = I
            For J = MaxScore To I Step -1
                If J > 1 Then
                    HiScore(J) = HiScore(J - 1)
                    HiName(J) = HiName(J - 1)
                End If
            Next J
            HiScore(I) = Score
            Exit For
        End If
    Next I
    
    'Show Score Sheet
    ScoreForm.Show
    
    'Enable the Text Box to Type In
    If ScorePosition > 0 Then
        ScoreForm.NameText(ScorePosition - 1).Text = ""
        ScoreForm.NameText(ScorePosition - 1).Enabled = True
        ScoreForm.NameText(ScorePosition - 1).SetFocus
    End If
    
    
End Sub
