Attribute VB_Name = "VB_GEN_FUNCS"
Option Explicit

'This DLL function colors in an area surrounded by a line.
'  It does this in the following manor
'  When wFillType = 0, then it fills in the area surrounded by crColor
'  When wFillType = 1, then it fills in the area of crColor,
'       any break in the color stops the fill
'*********************************************************************************
    Public Declare Function ExtFloodFill Lib "gdi32" (ByVal hdc As Long, _
        ByVal x As Long, ByVal y As Long, ByVal crColor As Long, _
        ByVal wFillType As Long) As Long
'*********************************************************************************

'*********************************************************************************
'This DLL function gets the state of key so that multiple keys can be held at the same time
    Public Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
'*********************************************************************************

'*********************************************************************************
'This DLL function gets the milliseconds since Windows started, use for accurate timing
    Public Declare Function GetTickCount Lib "kernel32" () As Long
'*********************************************************************************

'*********************************************************************************
'This DLL function draws an ellipse at the points (or circle)
    Public Declare Function Ellipse Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
'*********************************************************************************

'*********************************************************************************
'This DLL subroutine pauses everything for XX milliseconds
    Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
'*********************************************************************************

'*********************************************************************************
'These DLL functions allow the drawing of bitmaps onto a form
    Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
    Public Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
'*********************************************************************************

'*********************************************************************************
'These DLL functions allow the storing of bitmaps in separate files instead
'   of resource hogging picture boxes
    Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
    Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
    Public Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
    Public Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
    Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
    Public Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
    Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long

'*********************************************************************************

'*********************************************************************************
' Constants
    Public Const Pi = 3.14159               'Pi
'Constants for the GenerateDC function
    '**LoadImage Constants**
    Public Const IMAGE_BITMAP As Long = 0
    Public Const LR_LOADFROMFILE As Long = &H10
    Public Const LR_CREATEDIBSECTION As Long = &H2000
'*********************************************************************************

'*********************************************************************************
'Get a random integer between the Hi and Low numbers as arguments
    Function RandNum(Lo As Double, Hi As Double) As Long
        Randomize
        RandNum = Int(((Hi - Lo) * Rnd) + Lo) ' Generate random value between 1 and arg.
    End Function
'*********************************************************************************

'*********************************************************************************
'Use this function to rotate an X point about its origin
    Function X_Rotate(Angle As Double, X_Old As Double, Y_Old As Double) As Double
    
        Dim X1 As Double
        Dim X2 As Double
        Dim Angle1 As Double
        
        Angle1 = Radians(Angle)
        X1 = Cos(Angle1)
        X2 = Sin(Angle1)
        
        X_Rotate = X1 * X_Old + X2 * Y_Old
    
    End Function
'*********************************************************************************

'*********************************************************************************
'Use this function to rotate an Y point about its origin
    Function Y_Rotate(Angle As Double, X_Old As Double, Y_Old As Double) As Double
    
        Dim Y1 As Double
        Dim Y2 As Double
        Dim Angle1 As Double
        
        Angle1 = Radians(Angle)
        Y1 = -Sin(Angle1)
        Y2 = Cos(Angle1)
        
        Y_Rotate = Y1 * X_Old + Y2 * Y_Old
    
    End Function
'*********************************************************************************

'*********************************************************************************
'Convert degrees to radians (All trig functions use radians)
    Function Radians(arg As Double) As Double
    
        Radians = -arg * Pi / 180
        
    End Function
'*********************************************************************************

'*********************************************************************************
'*********************************************************************************
'       Handling DC class items for bitmap manipulation
'*********************************************************************************
'*********************************************************************************

    'IN: FileName: The file name of the graphics
    'OUT: The Generated DC
    Function GenerateDC(FileName As String) As Long
        Dim DC As Long
        Dim hBitmap As Long
        
        'Create a Device Context, compatible with the screen
            DC = CreateCompatibleDC(0)
                
        'Load the image....BIG NOTE: This function is not supported under NT, there you can not
        'specify the LR_LOADFROMFILE flag
            hBitmap = LoadImage(0, FileName, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE Or _
                LR_CREATEDIBSECTION)
        
            If hBitmap = 0 Then 'Failure in loading bitmap
                DeleteDC DC
                GenerateDC = 0
                'Raise error
                Err.Raise vbObjectError + 2
                Exit Function
            End If
        
        'Throw the Bitmap into the Device Context
            SelectObject DC, hBitmap
        
        'Return the device context
            GenerateDC = DC
        
        'Delte the bitmap handle object
            DeleteObject hBitmap
    
    End Function
    
    'Deletes a generated DC
    Function DeleteGeneratedDC(DC As Long) As Long
    
    If DC > 0 Then
        DeleteGeneratedDC = DeleteDC(DC)
    Else
        DeleteGeneratedDC = 0
    End If
    
    End Function

'*********************************************************************************
'*********************************************************************************
